function Domein(Nivos,Schaal)
%% Geef een grafische voorstelling van de model gegevens  (in Figure 1)
%% rivieren(blauwe lijnen), putten (blauwe punten), 
%% diffusie coefficienten (rode lijnen), stromings veld (groene pijlen)


global MyGRIDSIZE MyMODEL SHOWGRAPHS
nx=MyGRIDSIZE(1,1); ny=MyGRIDSIZE(1,2);
Model=MyMODEL;


[X0,Y0]=feval(Model,'gebied');

hx=X0/(nx+1); hy=Y0/(ny+1);
xi=[0:hx:X0]; yj=[0:hy:Y0];
[x,y]=ndgrid(xi,yj);

I=[0,0;X0,0]; J=[0,0;0,Y0];
plot(I,J,'b-'),axis([0,X0,0,Y0])
hold on   


[a,b]=feval(Model,x,y,'Diffusie');
contour(x,y,a,Nivos,'r-')
contour(x,y,b,Nivos,'r:')

[ug,vg]=feval(Model,x,y,'Advectie');
ADVECTION=(norm(ug,1)+norm(vg,1)>1);

if ADVECTION
if nx*ny<601
  Schaal=FindScale(ug,vg);
  quiver(x,y,ug,vg,Schaal,'go','MarkerSize',2)
else
  Nx=20;            Ny=20;
  Phx=X0/(Nx+1);    Phy=Y0/(Ny+1);
  Pxi=[1:Nx]*Phx;   Pyj=[1:Ny]*Phy;
  [Px,Py]=ndgrid(Pxi,Pyj);

  ii=round(Pxi/hx); jj=floor(Pyj/hy);
  r=Pxi/hx-ii;      s=Pyj/hy-jj;
  UU=diag(r)*(ug(ii+1,:)-ug(ii,:))+ug(ii,:);
  UU=(UU(:,jj+1)-UU(:,jj))*diag(s)+UU(:,jj);
 
  ii=floor(Pxi/hx); jj=round(Pyj/hy);
  r=Pxi/hx-ii;      s=Pyj/hy-jj;
  VV=diag(r)*(vg(ii+1,:)-vg(ii,:))+vg(ii,:);
  VV=(VV(:,jj+1)-VV(:,jj))*diag(s)+VV(:,jj);
  
  Schaal=FindScale(UU,VV);

  quiver(Px,Py,UU,VV,Schaal,'go','MarkerSize',2)
end
end

rivier=feval(Model,'rivier');
if ~isempty(rivier)
  [k1,l1]=size(rivier);
  sg=SHOWGRAPHS;
  SHOWGRAPHS=0;
  for kk=1:k1
    [Snijpunt,IndexRoosterpunt,kub]=Rivier(rivier(kk,:),nx,ny,X0,Y0);
    l=size(Snijpunt,2);
    plot(Snijpunt(1,[1,l]),Snijpunt(2,[1,l]),'b-','LineWidth',3)  
  end
  SHOWGRAPHS=sg;
end

pomp=feval(Model,'pomp');
if ~isempty(pomp)
  [k,l]=size(pomp);
  kk=1:k; 
  plot(pomp(kk,1),pomp(kk,2),'bo')
  plot(pomp(kk,1),pomp(kk,2),'b.','MarkerSize',20)
end
title('Model input')
xlabel('domein met rivieren, pompen, diffusie coefficient, stromingsveld')  

drawnow
hold off

return
%==================================
function S=FindScale(U,V)
% find a scaling of the velocity field
%

   [nx,ny]=size(U); n=nx*ny;
   Lu=reshape(U,n,1); Lv=reshape(V,n,1);
   L=sqrt(Lu.*Lu+Lv.*Lv);
   [L,J]=sort(L,'descend');
   k=min(30,length(L));
   S=L(1)/L(k);

return
