function [x,Rho,SUCCESS]=PGCR(A,b,x,kmax,tol,PreMV)
%[x,Rho,SUCCESS]=PGCR(A,b,x,kmax,tol,PeMV) 
%  PreMV is a string that defines a function subroutine that
%  performes the preconditioning. This function should takes one vector 
%  of dimension n = size(A,1) as input and it should return an n vector
%  as output.

% For instance if PreMV is the string 'Msolve', then 
%       u=feval(PreMV,r); 
% is the call  
%       u=Msolve(r);
% PreMV is this string 'Msolve' if PGCR is called (in main) as
% [x,Rho,SUCCESS]=PGCR(A,B,0*x,200,1.e-6,'Msolve');

% For a suggestion on how to implement Msolve,
% see the pdf "Incorporating preconditioners" 
% on the website for this course


if kmax==0, x=b; return, end

% find the dimension of the problem
n=size(b,1); 
ShowMethod('PGCR');


U=zeros([n(1),kmax]); C=U; Sigma=zeros(1,kmax); 

tol0=tol;
tol=tol(1)*tol(1)*(b'*b); 

% compute initial residual
r=b-A*x;
k=0;

Rho=rho; K=k;
while k<kmax

   if  rho<tol, break, end
 
%%%%%%%%%%%%% ????
%%%%%%%%%%%%% u=feval(PreMV,r);
%%%%%%%%%%%%% ????

   rho=r'*r;    
   Rho=[Rho,rho]; K=[K,k]; 
   ShowIntermediateSolution(x,k);
 
end
Rho=[sqrt(Rho);K];
SUCCESS=(k<kmax);

ShowConvergenceHist(K,Rho(1,:),SUCCESS,tol0,'PGCR')

return
